/*
 * Iris is a World Generator for Minecraft Bukkit Servers
 * Copyright (c) 2022 Arcane Arts (Volmit Software)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package com.volmit.iris.engine.object;

import com.volmit.iris.engine.object.annotations.Desc;

@Desc("The mob spawn group")
public enum IrisBiomeCustomSpawnType {
    @Desc("Typical monsters that spawn at night, like zombies and skeletons")
    MONSTER,

    @Desc("Typical creatures like sheep, pigs, cows")
    CREATURE,

    @Desc("Eg bats")
    AMBIENT,

    @Desc("Odd spawn group but ok")
    UNDERGROUND_WATER_CREATURE,

    @Desc("Water mobs like squid, dolphins")
    WATER_CREATURE,

    @Desc("Fish")
    WATER_AMBIENT,

    @Desc("Unknown")
    MISC
}
